<ui:composition template="/WEB-INF/templates/layout.xhtml"
	xmlns="http://www.w3.org/1999/xhtml"
	xmlns:h="http://xmlns.jcp.org/jsf/html"
	xmlns:f="http://xmlns.jcp.org/jsf/core"
	xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
	xmlns:p="http://primefaces.org/ui">

	<ui:param name="title" value="Tasks" />
	
	<ui:define name="content">
		<div class="layout-wrapper">
			<div class="layout">
				<div class="content-header">
					<h1>All tasks</h1>
					<p>This page containes all of the created tasks.</p>
				</div>
				<h:form id="tasksForm">
					<div class="p-grid">
						<div class="p-col-12">
							<div class="card all-tasks-card">
								<p:messages id="messages" globalOnly="true" showDetail="true">
									<p:autoUpdate />
								</p:messages>
								<div class="card-content">
									<p:dataTable id="tasksTable"
										rows="10"
										paginator="true" 
										paginatorTemplate="{CurrentPageReport} {FirstPageLink} {PreviousPageLink} {PageLink} {NextPageLink} {LastPageLink} {RowsPerPageDropdown}"
										rowsPerPageTemplate="10, 25, 50"
										scrollable="true"
										resizableColumns="true"
										liveResize="true"
										value="#{taskListBacking.taskList}" var="task"										
										selectionMode="single"
										selection="#{taskListBacking.selectedTask}"
										rowKey="#{task.id}"
										emptyMessage="You will tasks here as soon as they are created.">
										
										<p:ajax event="rowSelect" update=":tasksForm:tasksTable:btnEditTask" listener="#{taskListBacking.onRowSelect}" />
										<p:ajax event="rowSelect" update=":tasksForm:tasksTable:btnDeleteTask" listener="#{taskListBacking.onRowSelect}" />
										
										<f:facet name="header">
											<p:commandButton id="btnEditTask" 
												value="Edit"
												class="table-button" 
												process="tasksTable"
												action="#{taskListBacking.setParameters()}"
												update=":tasksDialog"
												oncomplete="PF('tasksDialog').show()" 
											 	icon="fas fa-pen" 
											 	disabled="#{taskListBacking.disabled}"/>
											 	
											<p:commandButton id="btnDeleteTask" 
												value="Delete"
												class="table-button" 
												process="tasksTable"
												action="#{taskListBacking.delete()}"
												update=":tasksForm:tasksTable"
												icon="fas fa-trash"
												disabled="#{taskListBacking.disabled}">
												<p:confirm header="Confirm deletion" message="Are you sure?" icon="fas fa-exclamation-circle" />
											</p:commandButton>
										</f:facet>
										
										<p:column headerText="Id" width="20" sortBy="#{task.id}">
											<h:outputText value="#{task.id}" />
										</p:column>
										<p:column headerText="Name" width="175" sortBy="#{task.name}">
											<h:outputText value="#{task.name}" />
										</p:column>
										<p:column headerText="Status" width="100" sortBy="#{task.status.name}">
											<h:outputText value="#{task.status.name}" />
										</p:column>
										<p:column headerText="Start date" width="75" sortBy="#{task.startDate}">
											<h:outputText value="#{task.startDate}" />
										</p:column>
										<p:column headerText="Due date" width="75" sortBy="#{task.dueDate}">
											<h:outputText value="#{task.dueDate}" />
										</p:column>
										<p:column headerText="Project" width="200" sortBy="#{task.project.name}">
											<h:outputText value="#{task.project.name}" />
										</p:column>
										<p:column headerText="Priority" width="75" sortBy="#{task.priority.name}">
											<h:outputText value="#{task.priority.name}" />
										</p:column>
										<p:column headerText="Assignee" width="125" sortBy="#{task.assignee.email}">
											<h:outputText value="#{task.assignee.email}" />
										</p:column>
									</p:dataTable>
								</div>
							</div>
						</div>
					</div>					
				</h:form>
				
				<p:confirmDialog global="true">
					<p:commandButton value="Confirm" styleClass="ui-confirmdialog-yes" icon="fas fa-check" />
					<p:commandButton value="Cancel" styleClass="ui-confirmdialog-no" icon="fas fa-times" />
				</p:confirmDialog>
				
				<p:dialog id="tasksDialog" widgetVar="tasksDialog" 
					header="Edit task" 
					modal="true" resizable="false">
					<h:form id="taskForm">
						<p:panelGrid columns="2">
							<p:outputLabel for="name" value="Name: " />
							<p:inputText id="name" value="#{taskListBacking.selectedTask.name}" />
							<p:outputLabel for="startDate" value="Start Date: " />
							<p:datePicker id="startDate" value="#{taskListBacking.selectedTask.startDate}"
								showOtherMonths="true"
								selectOtherMonths="false"
								monthNavigator="true"
								yearNavigator="true" />
							<p:outputLabel for="dueDate" value="Due date: " />
							<p:datePicker id="dueDate" value="#{taskListBacking.selectedTask.dueDate}"
								showOtherMonths="true"
								selectOtherMonths="false"
								monthNavigator="true"
								yearNavigator="true" />
							<p:outputLabel for="project" value="Project: " />
							<p:selectOneMenu id="project" value="#{taskListBacking.projectId}" effect="none">
								<f:selectItem itemLabel=" - Select an entry - " itemValue="0" noSelectionOption="true" />
								<f:selectItems value="#{taskBacking.projects}"
									var="project" 
									itemLabel="#{project.name}" 
									itemValue="#{project.id}" />
							</p:selectOneMenu>
							<p:outputLabel for="priority" value="Priority: " />
							<p:selectOneMenu id="priority" value="#{taskListBacking.priorityId}" effect="none">
								<f:selectItem itemLabel=" - Select an entry - " itemValue="0" noSelectionOption="true" />
								<f:selectItems value="#{taskBacking.priorities}"
									var="priority" 
									itemLabel="#{priority.name}"
									itemValue="#{priority.id}" />
							</p:selectOneMenu>
							<p:outputLabel for="assignee" value="Assignee: " />
							<p:selectOneMenu id="assignee" value="#{taskListBacking.assigneeId}" effect="none">
								<f:selectItem itemLabel=" - Select an entry - " itemValue="0" noSelectionOption="true" />
								<f:selectItems value="#{taskBacking.assignees}"
									var="assignee" 
									itemLabel="#{assignee.firstName} #{assignee.lastName}"
									itemValue="#{assignee.id}" />
							</p:selectOneMenu>
							<p:outputLabel for="status" value="Status: " />
							<p:selectOneMenu id="status" value="#{taskListBacking.statusId}" effect="none">
								<f:selectItem itemLabel=" - Select an entry - " itemValue="0" noSelectionOption="true" />
								<f:selectItems value="#{taskBacking.statuses}"
									var="status"
									itemLabel="#{status.name}"
									itemValue="#{status.id}" />
							</p:selectOneMenu>
						</p:panelGrid>
						
						<div class="btn-container popup">
							<p:commandButton id="submitEdit" 
								value="Submit"
								action="#{taskListBacking.update()}"
								oncomplete="PF('tasksDialog').hide()"
								update=":tasksForm:tasksTable" />
							<p:commandButton id="cancelEdit" 
								value="Cancel" 
								onclick="PF('tasksDialog').hide()"
								styleClass="cancel" />
						</div>
					</h:form>
				</p:dialog>
				
			</div>
		</div>
	
	</ui:define>	
	
</ui:composition>